#
# genpolish.awk,  4 Jun 23

# Generate a random reverse polish expression

# Build right to left

function addvar()
{
num_vars++
cur_vars++
expr="v " expr # choose variable later
}


function addoperator()
{
cur_vars--
expr="o " expr # choose operator later
}


function genexpr(total_vars)
{
cur_vars=2
num_vars=2
expr="v v" # Need two variables on stack
while (num_vars <= total_vars)
   {
   if (cur_vars == 1) # Must push a variable
      addvar()
   else
      if (rand() > VAROP) # 0.2 seems to produce reasonable expressions
         addvar()
      else
         addoperator()
   }
while (cur_vars > 1) # Add operators to use up operands
   addoperator()
print expr
}

BEGIN {
# NEXPR and VARS are command line options to awk
	if (NEXPR != "")
	   num_expr=NEXPR
	else
	   num_expr=10
	for (e=1; e <=num_expr; e++)
	   genexpr(VARS)
	}

