#
# polish2pref.awk,  4 Jun 23

# Convert a reverse polish expression to postfix form
# Randomly selecting the binary operators

# Input has the form:
# o v v
# o v o v v
# o v o v o v v
function eval(tnum)
{
if ($tnum == "o")
   {
   printf("(")
   tnum=eval(tnum+1) #recurse for lhs
   if (rand() <= PLUSMUL) # default 0.5
      printf("+")
   else
      printf("*")
#   printf("%s", binops[1+int(numops*rand())])
   tnum=eval(tnum) #recurse for rhs
   printf(")")
   }
else
   {
   tnum++
   printf("v[%d]", numvars)
   numvars++ # C is zero based
   }

return tnum
}

BEGIN {
	numexpr=0
	print "expr_type R[], v[];"
	print "void eval_expr()"
	print "{"

	}


	{
	numvars=0
	printf("R[%d] = ", numexpr)
	numexpr++ # C is zero based
	eval(1)
	printf(";\n")
	next
	}

END {
	# print "return(NULL)"
	printf("}\n\n\n")

	printf("#define NUMVARS %d\n", numvars)
	printf("#define NUMEXPR %d\n", numexpr)
	printf("expr_type R[NUMEXPR], v[NUMVARS];\n")
	# print "R=matrix(nrow=numvalues, ncol=numexpr)"
	# print "v=matrix(data=runif(numvalues*" numvars ", min=-1, max=1), nrow=numvalues, ncol=" numvars ")"
	# print "dum=eval_expr()"
	}

